代码随想录算法训练营Day36

力扣1049.最后一块石头的重量Ⅱ【medium】

力扣474.一和零【meidum】

一、力扣1049.最后一块石头的重量Ⅱ【medium】

题目链接:力扣1049.最后一块石头的重量Ⅱ

视频链接:代码随想录

1、思路

  • 把这个问题转换成尽可能将 stones 分成两个等分子集,这就和前两道题很相似了!
  • 时间复杂度: O ( m ∗ n ) O(m * n) O(m∗n)

2、代码

记忆化搜索
python 复制代码
class Solution:
    def lastStoneWeightII(self, stones: List[int]) -> int:
        s = sum(stones)
        m = s // 2
        @cache
        def dfs(i:int, c:int) -> int:
            if i < 0:
                return 0
            if c < stones[i]:
                return dfs(i - 1, c)
            return max(dfs(i - 1, c), dfs(i - 1, c - stones[i]) + stones[i])
        max_sum = dfs(len(stones) - 1, m)
        return  s - 2 * max_sum
dp:翻译递推
python 复制代码
class Solution:
    def lastStoneWeightII(self, stones: List[int]) -> int:
        s = sum(stones)
        n = len(stones)
        m = s // 2
        f = [[0] * (m + 1) for _ in range(n + 1)]
        f[0][0] = 0
        for i, x in enumerate(stones):
            for c in range(m + 1):
                if c < x :
                    f[i + 1][c] = f[i][c]
                else:
                    f[i + 1][c] = max(f[i][c], f[i][c - x] + x)
        return s - 2 * f[n][m]
空间优化:一维数组
python 复制代码
class Solution:
    def lastStoneWeightII(self, stones: List[int]) -> int:
        s = sum(stones)
        n = len(stones)
        m = s // 2
        f = [0] * (m + 1)
        for x in stones:
            for c in range(m, x - 1, -1):
                f[c] = max(f[c], f[c - x] + x)
        return s - 2 * f[m]

二、力扣474.一和零【meidum】

题目链接:力扣474.一和零

视频链接:代码随想录

1、思路

  • 这道题是0-1背包问题
  • 字符串列表里的元素就是物品,并且每个物品的数量为1
  • m 和 n 相当于是 2 个背包,这是这道题和之前不一样的地方 , 之前都是 1 个背包,所以这边只能用2 维的dp数组,因为要表示 2 个背包嘛
  • 我们之前处理空间优化------利用滚动数组的时候,一直都是正序遍历物品,再倒序遍历背包,可以避免重复计数
  • 时间复杂度: O ( k ∗ m ∗ n ) O(k*m*n) O(k∗m∗n)

2、代码

python 复制代码
class Solution:
    def findMaxForm(self, strs: List[str], m: int, n: int) -> int:
        dp = [[0] * (n + 1) for _ in range(m + 1) ]
        for s in strs:
            zeronum = s.count('0')
            onenum = s.count('1')
            for i in range(m, zeronum - 1, -1):
                for j in range(n, onenum - 1, -1):
                    dp[i][j] = max(dp[i][j], dp[i -zeronum][j - onenum] + 1)
        return dp[m][n]

相关推荐
北极有牛24 分钟前
cpp学习笔记--常量指针
java·开发语言·算法
GPU实战笔记25 分钟前
云端 GPU 训练的账户余额提醒:它能说明什么,不能说明什么?
深度学习·算法·成本管理·gpu云计算·云端训练
浮链序1 小时前
怎么证明"你这个模型是偷我的"——把蒸馏变成取证工具
算法·安全·llm
小O的算法实验室1 小时前
IEEE TMC,面向异构物联网的多目标量子行为拓扑优化算法
算法
liliangcsdn2 小时前
派息率指标的应用探索和分析
大数据·算法
垆边人似月.2 小时前
华为机试题 :两数之和
c++·算法·华为
默默开发2 小时前
物流行业可用算法方向
算法
垆边人似月.2 小时前
华为机试题 :有效的括号
c++·算法·华为
A加ITIL教练长河achotsao3 小时前
ITIL Master 战略领导者课后系列分享:AI编程正在重新划分研发与运维的边界
算法
hahaha60163 小时前
FPGA+ARM实现AWB的全流程
人工智能·嵌入式硬件·算法·计算机视觉·fpga开发